<template>

  <Head>
    <title>Categories - GreenK Cashier</title>
  </Head>
  <main class="c-main">
    <div class="container-fluid">
      <div class="fade-in">
        <div class="row">
          <div class="col-md-12">
            <div class="card border-0 rounded-3 shadow border-top-purple">
              <!-- text header -->
              <div class="card-header bg-primary text-white">
                <span class="font-weight-bold"><i class="fa fa-folder me-2"></i> CATEGORIES</span>
              </div>
              <div class="card-body">
                <div class="row">
                  <!-- button link view to create category -->
                  <div class="col-md-6">
                    <Link href="/apps/categories/create" v-if="hasAnyPermission(['categories.create'])"
                      class="btn btn-primary input-group-text"> <i class="fa fa-plus-circle me-2"></i> Create Category
                    </Link>
                  </div>
                  <!-- form search -->
                  <div class="col-md-6">
                    <form @submit.prevent="handleSearch">
                      <div class="input-group mb-3">
                        <input type="text" class="form-control" v-model="search" placeholder="Search Category...">
                        <button class="btn btn-primary input-group-text" type="submit">
                          <i class="fa fa-search me-2"></i>
                        </button>
                      </div>
                    </form>
                  </div>
                </div>

                <!-- table of categories -->
                <div class="table-responsive">
                  <table class="table table-hover">
                    <thead class="bg-primary text-white">
                      <tr>
                        <th scope="col" style="width: 75px">#</th>
                        <th scope="col">Name</th>
                        <th scope="col">Image</th>
                        <th scope="col" style="width:20%">Actions</th>
                      </tr>
                    </thead>
                    <tbody>
                      <tr v-for="(category, index) in categories.data" :key="index">
                        <td class="fw-bold text-center">
                          {{ ++index + (categories.current_page - 1) *
                          categories.per_page }}
                        </td>
                        <td>{{ category.name }}</td>
                        <td><img :src="category.image" width="40"></td>
                        <td class="text-center">
                          <!-- link view edit -->
                          <Link :href="`/apps/categories/${category.slug}/edit`"
                            v-if="hasAnyPermission(['categories.edit'])"
                            class="btn btn-info btn-sm mb-md-0 mx-1 mb-2 mb-sm-0"><i
                            class="fa fa-pencil-alt text-white fa-fw"></i>
                          </Link>
                          <!-- button delete -->
                          <button @click.prevent="destroy(category.slug)" v-if="hasAnyPermission(['categories.delete'])"
                            class="btn btn-danger btn-sm mx-1"><i class="fa fa-trash fa-fw"></i>
                          </button>
                        </td>
                      </tr>
                    </tbody>
                  </table>
                </div>
                <!-- pagination -->
                <Pagination :links="categories.links" align="end" />
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </main>
</template>

<script>
// import layout
import LayoutApp from '../../../Layouts/App.vue';

// import component pagination
import Pagination from '../../../Components/Pagination.vue';

// import Head and Link from inertia
import { Head, Link } from '@inertiajs/vue3';

// import ref from vue
import { ref } from 'vue';

// import inertia adapter
import { router } from '@inertiajs/vue3';

// import sweet alert 2
import Swal from 'sweetalert2';

export default {
  // layout
  layout: LayoutApp,

  // register component
  components: {
    Head,
    Link,
    Pagination
  },

  // props
  props: {
    categories: Object,
  },

  // composition API
  setup() {

    // define state search
    const search = ref('' || (new URL(document.location)).searchParams.get('q'));

    // define method search
    const handleSearch = () => {
      router.get('/apps/categories', {

        // send params "q" with value from state "search"
        q: search.value,
      });
    }

    // define method destroy
    const destroy = (slug) => {
      Swal.fire({
        title: 'Are you sure?',
        text: "You won't be able to revert this!",
        icon: 'warning',
        showCancelButton: true,
        confirmButtonColor: '#3085d6',
        cancelButtonColor: '#d33',
        confirmButtonText: 'Yes, delete it!'
      })
        .then((result) => {
          if (result.isConfirmed) {
            router.delete(`/apps/categories/${slug}`);
            Swal.fire({
              title: 'Deleted!',
              text: 'Category has been deleted.',
              icon: 'success',
              timer: 2000,
              showConfirmButton: false,
            });
          }
        })
    }

    // return
    return {
      search,
      handleSearch,
      destroy
    }

  }
}
</script>

<style scoped>
th, td {
  text-align: center;
}
</style>